@echo off
set user=
set password=

set testName=
set stepName=
set testType=
set status=
set url=
set folderName=

set fileformat=xml
set time=ARRIVAL
set detaillevel=TEST
set cURL=.\curl-7.36.0-win32\bin\curl.exe
set xmlStarlet=.\xmlstarlet-1.5.0\xml.exe
set gawk=.\gawk-3.1.6-1-bin\bin\gawk.exe

%cURL% --silent --output _RestAuthToken.json --header "Accept: application/json"^
	--url "https://datafeed-api.dynatrace.com/publicapi/rest/v1.0/login?user=%user%&password=%password%"
set /p RestAuthToken=<_RestAuthToken.json

%cURL% -X GET --silent --output _TestList.xml --header "Authentication: bearer %RestAuthToken%" --header "Accept: application/xml" ^
 	--get --url "https://datafeed-api.dynatrace.com/publicapi/rest/v1.0/tests?testName=%testName%&stepName=%stepName%&testType=%testType%&status=%status%&url=%url%&folderName" 

%xmlStarlet% sel --xml-decl --noblanks --template --elem "TESTDATA_INPUT" --elem "MonitorSet"^
 	--match "/DocumentTag/Monitors/Monitor" --elem "Monitor" --elem "mid" --value-of "monitorID" _testList.xml> _dataFeedPost.xml

type _testList.xml > .\DATA\REST_MonitorList.xml

if exist lastpolltimeepoch.dat < lastpolltimeepoch.dat (set /p starttime=) ^
	else (%gawk% --assign offset=600 --file ./services/awksrc/timestampepoch.awk > lastpolltimeepoch.dat
	set /p starttime=<lastpolltimeepoch.dat)

%gawk% --assign offset=0 --file ./services/awksrc/timestampepoch.awk > lastpolltimeepoch.dat
set /p endtime=<lastpolltimeepoch.dat

%cURL% -X POST --output ./DATA/REST_MonitorData.%fileformat% --header "Authentication: bearer %RestAuthToken%" ^
	--header "Content-Type: application/xml" --header "Accept: application/%fileformat%" ^
	--url "https://datafeed-api.dynatrace.com/publicapi/rest/v1.0/testresults?time=%time%&detaillevel=%detaillevel%&start=%starttime%&end=%endtime%" ^
 	--data @_dataFeedPost.xml 

if %ERRORLEVEL% == 0 ( erase /Q _*.* )